// FoldDlg.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "BrowseForFolder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DLLExport _declspec(dllexport)
extern "C" DLLExport LPCTSTR GetFolder();

static AFX_EXTENSION_MODULE FoldDlgDLL = { NULL, NULL };

CBrowseForFolder *wndFoldDlg;
CString the_strPath;

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("FOLDDLG.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(FoldDlgDLL, hInstance))
			return 0;
		wndFoldDlg = new CBrowseForFolder;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(FoldDlgDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		delete wndFoldDlg;
		TRACE0("FOLDDLG.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(FoldDlgDLL);
	}
	return 1;   // ok
}

extern "C" DLLExport LPCTSTR GetFolder()
{
	wndFoldDlg -> strStartupDir;
	BOOL bRet;
	bRet = wndFoldDlg -> GetFolder(the_strPath);
	if(bRet)
		return (LPCTSTR)the_strPath;
	else
		return NULL;
}
